import { TextEdit } from "vscode-languageserver";
import { SyntaxNode, Tree } from "web-tree-sitter";
export declare class RefactorEditUtils {
    static unexposedValueInModule(tree: Tree, valueName: string): TextEdit | undefined;
    static exposeValueInModule(tree: Tree, valueName: string): TextEdit | undefined;
    static removeValueFromImport(tree: Tree, moduleName: string, valueName: string): TextEdit | undefined;
    static addImport(tree: Tree, moduleName: string, valueName?: string): TextEdit | undefined;
    static changeQualifiedReferenceModule(node: SyntaxNode, newModuleName: string): TextEdit | undefined;
    static removeQualifiedReference(node: SyntaxNode): TextEdit | undefined;
    static addImports(tree: Tree, importData: {
        moduleName: string;
        valueName?: string;
    }[]): TextEdit | undefined;
    private static removeValueFromExposingList;
}
