import { ClientCapabilities, IConnection } from "vscode-languageserver";
export interface IClientSettings {
    elmFormatPath: string;
    elmPath: string;
    elmTestPath: string;
    elmAnalyseTrigger: ElmAnalyseTrigger;
    trace: {
        server: string;
    };
    extendedCapabilities?: IExtendedCapabilites;
}
export interface IExtendedCapabilites {
    moveFunctionRefactoringSupport: boolean;
    exposeUnexposeSupport: boolean;
}
export declare type ElmAnalyseTrigger = "change" | "save" | "never";
export declare class Settings {
    private connection;
    private clientCapabilities;
    private clientSettings;
    private initDone;
    constructor(connection: IConnection, config: any, clientCapabilities: ClientCapabilities);
    initFinished(): void;
    getClientSettings(): Promise<IClientSettings>;
    get extendedCapabilities(): IExtendedCapabilites | undefined;
    private updateSettings;
}
